#----------------------------------------------
#----------------------------------------------

require 'sketchup.rb'
require 'extensions.rb'
require 'LangHandler.rb'


if (not $sn_loaded)


#----------------------------------------------
pejman_toolbars = UI::Toolbar.new("Pejman's Favorites ")


#----------------------------------------------
#----------------------------------------------

cmd1 = UI::Command.new("Iso") { Sketchup.send_action "viewIso:" }
cmd1.small_icon = "pejmantoolbar/viewIso_sm.png"
cmd1.large_icon = "pejmantoolbar/viewIso_lg.png"
cmd1.tooltip = "Iso View"
cmd1.status_bar_text = "Iso View"
cmd1.menu_text = "Iso"
# cmd1.set_validation_proc { tool_validation_proc("ArcTool") }
pejman_toolbars.add_item(cmd1)

#----------------------------------------------
cmd2 = UI::Command.new("Top") { Sketchup.send_action "viewTop:" }
cmd2.small_icon = "pejmantoolbar/viewTop_sm.png"
cmd2.large_icon = "pejmantoolbar/viewTop_lg.png"
cmd2.tooltip = "Top View"
cmd2.status_bar_text = "Top View"
cmd2.menu_text = "Top"
# cmd2.set_validation_proc { tool_validation_proc("ArcTool") }
pejman_toolbars.add_item(cmd2)

#----------------------------------------------
cmd3 = UI::Command.new("Front") { Sketchup.send_action "viewFront:" }
cmd3.large_icon = "pejmantoolbar/viewFront_lg.png"
cmd3.small_icon = "pejmantoolbar/viewFront_sm.png"
cmd3.tooltip = "Front View"
cmd3.status_bar_text = "Front View"
cmd3.menu_text = "Front"
# cmd3.set_validation_proc { tool_validation_proc("ArcTool") }
pejman_toolbars.add_item(cmd3)

#----------------------------------------------
cmd4 = UI::Command.new("Right") { Sketchup.send_action "viewRight:" }
cmd4.small_icon = "pejmantoolbar/viewRight_sm.png"
cmd4.large_icon = "pejmantoolbar/viewRight_lg.png"
cmd4.tooltip = "Right View"
cmd4.status_bar_text = "Right View"
cmd4.menu_text = "Right"
# cmd4.set_validation_proc { tool_validation_proc("ArcTool") }
pejman_toolbars.add_item(cmd4)

#----------------------------------------------
cmd6 = UI::Command.new("Back") { Sketchup.send_action "viewBack:" }
cmd6.small_icon = "pejmantoolbar/viewBack_sm.png"
cmd6.large_icon = "pejmantoolbar/viewBack_lg.png"
cmd6.tooltip = "Back View"
cmd6.status_bar_text = "Back View"
cmd6.menu_text = "Back"
# cmd6.set_validation_proc { tool_validation_proc("ArcTool") }
pejman_toolbars.add_item(cmd6)

#----------------------------------------------
cmd5 = UI::Command.new("Left") { Sketchup.send_action "viewLeft:" }
cmd5.small_icon = "pejmantoolbar/viewLeft_sm.png"
cmd5.large_icon = "pejmantoolbar/viewLeft_lg.png"
cmd5.tooltip = "Left View"
cmd5.status_bar_text = "Left View"
cmd5.menu_text = "Left"
# cmd5.set_validation_proc { tool_validation_proc("ArcTool") }
pejman_toolbars.add_item(cmd5)

#----------------------------------------------
cmd7 = UI::Command.new("Bottom") { Sketchup.send_action "viewBottom:" }
cmd7.small_icon = "pejmantoolbar/viewBottom_sm.png"
cmd7.large_icon = "pejmantoolbar/viewBottom_lg.png"
cmd7.tooltip = "Bottom View"
cmd7.status_bar_text = "Bottom View"
cmd7.menu_text = "Bottom"
# cmd7.set_validation_proc { tool_validation_proc("ArcTool") }
pejman_toolbars.add_item(cmd7)

#----------------------------------------------
cmd8 = UI::Command.new("View Perspective") {
  Sketchup.send_action "viewPerspective:"
}
cmd8.large_icon = "pejmantoolbar/toggleperspective_lg.png"
cmd8.small_icon = "pejmantoolbar/toggleperspective_sm.png"
cmd8.tooltip = "Camera Perspective"
cmd8.status_bar_text = "Camera Perspective"
def perspective_validation_proc
  if Sketchup.active_model.active_view.camera.perspective?
    return MF_CHECKED
  else
    return MF_UNCHECKED
  end
end
cmd8.set_validation_proc { perspective_validation_proc }
pejman_toolbars.add_item(cmd8)

#----------------------------------------------
pejman_toolbars.add_separator
#----------------------------------------------

cmd9 = UI::Command.new("Xray") {
  Sketchup.active_model.rendering_options["ModelTransparency"] = ! Sketchup.active_model.rendering_options["ModelTransparency"]
}
cmd9.small_icon = "pejmantoolbar/toggleXray_sm.png"
cmd9.large_icon = "pejmantoolbar/toggleXray_lg.png"
cmd9.tooltip = "Xray"
cmd9.status_bar_text = "Xray"
cmd9.menu_text = "Xray"
def xrayvp
  if Sketchup.active_model.rendering_options["ModelTransparency"] == true
    return MF_CHECKED
  else
    return MF_UNCHECKED
  end
end  
cmd9.set_validation_proc { xrayvp }
pejman_toolbars.add_item(cmd9)

#----------------------------------------------
cmd10 = UI::Command.new("WireFrame") {
  Sketchup.active_model.rendering_options["RenderMode"] = 0
}
cmd10.small_icon = "pejmantoolbar/renderwireframe_sm.png"
cmd10.large_icon = "pejmantoolbar/renderwireframe_lg.png"
cmd10.tooltip = "Wireframe"
cmd10.status_bar_text = "Wireframe"
cmd10.menu_text = "Wireframe"
def wireframevp
  if Sketchup.active_model.rendering_options["RenderMode"] == 0
    return MF_CHECKED
  else
    return MF_UNCHECKED
  end
end  
cmd10.set_validation_proc { wireframevp }
pejman_toolbars.add_item(cmd10)

#----------------------------------------------
cmd11 = UI::Command.new("HiddenLine") {
  Sketchup.active_model.rendering_options["RenderMode"] = 1
}
cmd11.small_icon = "pejmantoolbar/renderhiddenline_sm.png"
cmd11.large_icon = "pejmantoolbar/renderhiddenline_lg.png"
cmd11.tooltip = "Hidden Line"
cmd11.status_bar_text = "Hidden Line"
cmd11.menu_text = "Hidden Line"
def hiddenlinevp
  if Sketchup.active_model.rendering_options["RenderMode"] == 1
    return MF_CHECKED
  else
    return MF_UNCHECKED
  end
end  
cmd11.set_validation_proc { hiddenlinevp }
pejman_toolbars.add_item(cmd11)

#----------------------------------------------
cmd12 = UI::Command.new("Shaded") {
  Sketchup.active_model.rendering_options["RenderMode"] = 2
  Sketchup.active_model.rendering_options["Texture"] = false
}
cmd12.small_icon = "pejmantoolbar/rendershaded_sm.png"
cmd12.large_icon = "pejmantoolbar/rendershaded_lg.png"
cmd12.tooltip = "Shaded"
cmd12.status_bar_text = "Shaded"
cmd12.menu_text = "Shaded"
def shaded_vp
  if Sketchup.active_model.rendering_options["RenderMode"] == 2 and Sketchup.active_model.rendering_options["Texture"] == false
    return MF_CHECKED
  else
    return MF_UNCHECKED
  end
end  
cmd12.set_validation_proc { shaded_vp }
pejman_toolbars.add_item(cmd12)

#----------------------------------------------
cmd13 = UI::Command.new("Textured") {
  Sketchup.active_model.rendering_options["RenderMode"] = 2
  Sketchup.active_model.rendering_options["Texture"] = true
}
cmd13.small_icon = "pejmantoolbar/rendertextured_sm.png"
cmd13.large_icon = "pejmantoolbar/rendertextured_lg.png"
cmd13.tooltip = "Textured"
cmd13.status_bar_text = "Textured"
cmd13.menu_text = "Textured"
def textured_vp
  if Sketchup.active_model.rendering_options["RenderMode"] == 2 and Sketchup.active_model.rendering_options["Texture"] == true
    return MF_CHECKED
  else
    return MF_UNCHECKED
  end
end  
cmd13.set_validation_proc { textured_vp }
pejman_toolbars.add_item(cmd13)

#----------------------------------------------
cmd14 = UI::Command.new("Monochrome") { Sketchup.active_model.rendering_options["RenderMode"] = 5 }
cmd14.small_icon = "pejmantoolbar/rendermonochrome_sm.png"
cmd14.large_icon = "pejmantoolbar/rendermonochrome_lg.png"
cmd14.tooltip = "Monochrome"
cmd14.status_bar_text = "Monochrome"
cmd14.menu_text = "Monochrome"
def monochromevp
  if Sketchup.active_model.rendering_options["RenderMode"] == 5
    return MF_CHECKED
  else
    return MF_UNCHECKED
  end
end  
cmd14.set_validation_proc { monochromevp }
pejman_toolbars.add_item(cmd14)


#----------------------------------------------
pejman_toolbars.add_separator
#----------------------------------------------


cmd60 = UI::Command.new("Paste In Place")  { Sketchup.send_action 21939 } 
cmd60.small_icon = "pejmantoolbar/pasteinplace_SM.png"
cmd60.large_icon = "pejmantoolbar/pasteinplace_LG.png"
cmd60.tooltip = "Paste In Place"
cmd60.status_bar_text = "Paste in Place"
pejman_toolbars.add_item(cmd60)

#----------------------------------------------

cmd61 = UI::Command.new("Make Group") { Sketchup.send_action 21182 }
cmd61.small_icon = "pejmantoolbar/makegroup_sm.png"
cmd61.large_icon = "pejmantoolbar/makegroup_lg.png"
cmd61.tooltip = cmd61.status_bar_text = "Make Group"
pejman_toolbars.add_item(cmd61)


#----------------------------------------------


def toolbar_explode
ss = Sketchup.active_model.selection
Sketchup.active_model.start_operation "ungroup"
ss.each do |s|
if s.respond_to? "explode"
ents = s.explode
ents = ents.select {|e| e.is_a? Sketchup::Drawingelement}
ss.add ents
end
end
Sketchup.active_model.commit_operation
end
def explode_validation_proc
ss = Sketchup.active_model.selection
return MF_GRAYED unless ss.length > 0
ss = ss.select {|s| s.respond_to? "explode"}
if ss.length > 0
return MF_ENABLED
else
return MF_GRAYED
end
end
cmd62 = UI::Command.new("Explode") { toolbar_explode }
cmd62.large_icon = "pejmantoolbar/ungroup_lg.png"
cmd62.small_icon = "pejmantoolbar/ungroup_sm.png"
cmd62.tooltip = cmd62.status_bar_text = "Explode"
pejman_toolbars.add_item(cmd62)


#----------------------------------------------
pejman_toolbars.add_separator
#----------------------------------------------

cmd15 = UI::Command.new("Toggle Hidden") {
  Sketchup.send_action "viewShowHidden:"
}
cmd15.large_icon = "pejmantoolbar/togglehidden_lg.png"
cmd15.small_icon = "pejmantoolbar/togglehidden_sm.png"
cmd15.tooltip = "Show Hidden Geometry"
cmd15.status_bar_text = "Show Hidden Geometry"
def hidden_validation_proc
  if Sketchup.active_model.rendering_options["DrawHidden"] == true
  return MF_CHECKED
  else
  return MF_UNCHECKED
  end
end
cmd15.set_validation_proc { hidden_validation_proc }
pejman_toolbars.add_item(cmd15)

#----------------------------------------------
cmd16 = UI::Command.new("HiddenLine") { Sketchup.send_action "editHide:" }
cmd16.small_icon = "pejmantoolbar/hideselected_sm.png"
cmd16.large_icon = "pejmantoolbar/hideselected_lg.png"
cmd16.tooltip = "Hide Selected Geometry"
cmd16.status_bar_text = "Hide Selected Geometry"
def hideSelected_validation_proc
  if Sketchup.active_model.selection.length < 1
    return MF_GRAYED
  else
    return MF_ENABLED
  end
end
cmd16.set_validation_proc { hideSelected_validation_proc }
pejman_toolbars.add_item(cmd16)

#----------------------------------------------
cmd17 = UI::Command.new("HiddenLine") { Sketchup.send_action "editUnhide:" }
cmd17.small_icon = "pejmantoolbar/unhideselected_sm.png"
cmd17.large_icon = "pejmantoolbar/unhideselected_lg.png"
cmd17.tooltip = "Unhide Selected Geometry"
cmd17.status_bar_text = "Unhide Selected Geometry"
def unhideSelected_validation_proc
  if Sketchup.active_model.selection.length < 1
    return MF_GRAYED
  else
    return MF_ENABLED
  end
end
cmd17.set_validation_proc { hideSelected_validation_proc }
pejman_toolbars.add_item(cmd17)

#----------------------------------------------
pejman_toolbars.add_separator
#----------------------------------------------

cmd18 = UI::Command.new("Toggle Axes") {
  Sketchup.send_action "viewShowAxes:"
}
cmd18.large_icon = "pejmantoolbar/toggleAxes_lg.png"
cmd18.small_icon = "pejmantoolbar/toggleAxes_sm.png"
cmd18.tooltip = "Toggle Axes"
cmd18.status_bar_text = "Toggle Axes"
def edges_validation_proc
  if Sketchup.active_model.rendering_options["EdgeDisplayMode"] == 0
  return MF_CHECKED
  else
  return MF_UNCHECKED
  end
end
cmd18.set_validation_proc { edges_validation_proc }
pejman_toolbars.add_item(cmd18)

#----------------------------------------------
cmd19 = UI::Command.new("Hide Guides") {
  Sketchup.active_model.rendering_options["HideConstructionGeometry"] = !Sketchup.active_model.rendering_options["HideConstructionGeometry"]
}
# fn = File.basename(__FILE__, ".rb")
cmd19.large_icon = "pejmantoolbar/ToggleGuides_lg.png"
cmd19.small_icon = "pejmantoolbar/ToggleGuides_sm.png"
cmd19.tooltip = cmd19.status_bar_text = "Display Construction Geometry"
def guides_validation_proc
  if Sketchup.active_model.rendering_options["HideConstructionGeometry"] == false 
    return MF_CHECKED
  else
    return MF_UNCHECKED
  end
end
cmd19.set_validation_proc { guides_validation_proc }
pejman_toolbars.add_item(cmd19)

#----------------------------------------------
cmd20 = UI::Command.new("CameraZoom") { Sketchup.send_action "selectZoomWindowTool:" }
cmd20.small_icon = "pejmantoolbar/zoomWindow_sm.png"
cmd20.large_icon = "pejmantoolbar/zoomWindow_lg.png"
cmd20.tooltip = "ZoomWindow"
cmd20.status_bar_text = "ZoomWindow"
cmd20.menu_text = "ZoomWindow"
#cmd20.set_validation_proc { tool_validation_proc("CameraZoomWindowTool") }
pejman_toolbars.add_item(cmd20)


#----------------------------------------------
pejman_toolbars.add_separator
#----------------------------------------------


cmd21 = UI::Command.new("Hide Rest") {
  Sketchup.active_model.rendering_options["InactiveHidden"] = !Sketchup.active_model.rendering_options["InactiveHidden"]
}
cmd21.large_icon = "pejmantoolbar/hideRest_lg.png"
cmd21.small_icon = "pejmantoolbar/hideRest_lg.png"
cmd21.tooltip = "Hide Rest of Model"
cmd21.status_bar_text  = "Hide Rest of Model"
def hide_rest_validation_proc
  if Sketchup.active_model.rendering_options["InactiveHidden"] == true
    return MF_CHECKED
  else
    return MF_UNCHECKED
  end
end
cmd21.set_validation_proc { hide_rest_validation_proc }
pejman_toolbars.add_item(cmd21)


#----------------------------------------------
cmd22 = UI::Command.new("hideSimilar") {
  Sketchup.active_model.rendering_options["InstanceHidden"] = !Sketchup.active_model.rendering_options["InstanceHidden"]
}
cmd22.large_icon = "pejmantoolbar/hideSimilar_lg.png"
cmd22.small_icon = "pejmantoolbar/hideSimilar_lg.png"
cmd22.tooltip = "Hide Similar Components"
cmd22.status_bar_text  = "Hide Similar Components"
def instance_validation_proc
  if Sketchup.active_model.rendering_options["InstanceHidden"] == true
  return MF_CHECKED
  else
  return MF_UNCHECKED
  end
end
cmd22.set_validation_proc { instance_validation_proc }
pejman_toolbars.add_item(cmd22)



#----------------------------------------------
pejman_toolbars.add_separator
#----------------------------------------------

#
# 
cmd23 = UI::Command.new("Display Edges") {
  if Sketchup.active_model.rendering_options["EdgeDisplayMode"] == 0
    Sketchup.active_model.rendering_options["EdgeDisplayMode"] = 1
  else
    Sketchup.active_model.rendering_options["EdgeDisplayMode"] = 0
  end
}
cmd23.large_icon = "pejmantoolbar/toggleedges_lg.png"
cmd23.small_icon = "pejmantoolbar/toggleedges_sm.png"
cmd23.tooltip = "Display Edges"
cmd23.status_bar_text = "Display Edges"
def edges_validation_proc
  if Sketchup.active_model.rendering_options["EdgeDisplayMode"] == 0
    return MF_UNCHECKED
  else
    return MF_CHECKED
  end
end
cmd23.set_validation_proc { edges_validation_proc }
pejman_toolbars.add_item(cmd23)

#----------------------------------------------
def toggleProfiles
  @t = Time.now
  opts = Sketchup.active_model.rendering_options
  len = opts["SilhouetteWidth"]
  state = opts["DrawSilhouettes"]
  if @l
    if @t - @l < 0.3
      opts["DrawSilhouettes"] = true
      ret = inputbox ["New width:"], [len], "Change Profile Width" 
      return unless ret
      opts["SilhouetteWidth"] = ret[0]
      return
    end
  end
  opts["DrawSilhouettes"] = ! state
  @l = @t
end
cmd24 = UI::Command.new("Profiles") {
  #Sketchup.active_model.rendering_options["DrawSilhouettes"] = !Sketchup.active_model.rendering_options["DrawSilhouettes"]
  toggleProfiles
}
cmd24.large_icon = "pejmantoolbar/toggleprofiles_lg.png"
cmd24.small_icon = "pejmantoolbar/toggleprofiles_sm.png"
cmd24.tooltip = "Display Profiles"
cmd24.status_bar_text  = "Display Profiles"
def profiles_validation_proc
  if Sketchup.active_model.rendering_options["DrawSilhouettes"] == true
    return MF_CHECKED
  else
    return MF_UNCHECKED
  end
end
cmd24.set_validation_proc { profiles_validation_proc }
pejman_toolbars.add_item(cmd24)

#----------------------------------------------
def toggleDepthQue
  @t = Time.now
  opts = Sketchup.active_model.rendering_options
  len = opts["DepthQueWidth"]
  state = opts["DrawDepthQue"]
  if @l
    if @t - @l < 0.3
      opts["DrawDepthQue"] = true
      ret = inputbox ["New Width:"], [len], "Change Depth Cue Width" 
      return unless ret
      opts["DepthQueWidth"] = ret[0]
      return
    end
  end
  opts["DrawDepthQue"] = ! state
  @l = @t
end
cmd25 = UI::Command.new("DepthCue") {
  #Sketchup.active_model.rendering_options["DrawDepthQue"] = !Sketchup.active_model.rendering_options["DrawDepthQue"]
  toggleDepthQue
}
cmd25.large_icon = "pejmantoolbar/toggleDepthCue_lg.png"
cmd25.small_icon = "pejmantoolbar/toggleDepthCue_sm.png"
cmd25.tooltip = "Display DepthCue"
cmd25.status_bar_text  = "Display DepthCue"
def depthcue_validation_proc
  if Sketchup.active_model.rendering_options["DrawDepthQue"] == true
    return MF_CHECKED
  else
    return MF_UNCHECKED
  end
end
cmd25.set_validation_proc { depthcue_validation_proc }
pejman_toolbars.add_item(cmd25)

#----------------------------------------------
cmd26 = UI::Command.new("Color By Layer") {
  Sketchup.active_model.rendering_options["DisplayColorByLayer"] = !Sketchup.active_model.rendering_options["DisplayColorByLayer"]
}
# img = File.basename(__FILE__, ".rb")
cmd26.large_icon = "pejmantoolbar/ToggleColorByLayer_lg.png"
cmd26.small_icon = "pejmantoolbar/ToggleColorByLayer_sm.png"
cmd26.tooltip = "Toggle ColorByLayer"
cmd26.status_bar_text  = "Toggle ColorByLayer"
def color_by_layer_validation_proc
  if Sketchup.active_model.rendering_options["DisplayColorByLayer"] == true
  return MF_CHECKED
  else
  return MF_UNCHECKED
  end
end
cmd26.set_validation_proc { color_by_layer_validation_proc }
pejman_toolbars.add_item(cmd26)

#----------------------------------------------
cmd27 = UI::Command.new("Edge Color Mode") do
  ro = Sketchup.active_model.rendering_options
  ecm = ro["EdgeColorMode"]
  ecm = ((ecm + 1) % 3)
  ro["EdgeColorMode"] = ecm
  Sketchup.set_status_text "Egde Color Mode: " + ["by Material", "All Same", "by Axis"][ecm]
end
cmd27.large_icon = "pejmantoolbar/edgeColorMode_lg.png"
cmd27.small_icon = "pejmantoolbar/edgeColorMode_sm.png"
cmd27.tooltip = "Cycle Edge Color Mode"
cmd27.status_bar_text = "Cycle Edge Color"
pejman_toolbars.add_item(cmd27)

#----------------------------------------------
pejman_toolbars.add_separator
#----------------------------------------------

def toggleFog
  @t = Time.now
  ro  = Sketchup.active_model.rendering_options
  fog = ro["DisplayFog"]
  if @l
    if @t - @l < 0.3
      Sketchup.send_action 21406
      ro["DisplayFog"] = true
      return
    end
  end
  ro["DisplayFog"] = ! ro["DisplayFog"]
  @l = @t
end

cmd28 = UI::Command.new("Fog") { toggleFog }
# img = File.basename(__FILE__, ".rb")
cmd28.large_icon = "pejmantoolbar/ToggleFog_lg.png"
cmd28.small_icon = "pejmantoolbar/ToggleFog_sm.png"
cmd28.tooltip = cmd28.status_bar_text = "Display Fog"
def fog_validation_proc
  if Sketchup.active_model.rendering_options["DisplayFog"] == true
    return MF_CHECKED
  else
    return MF_UNCHECKED
  end
end
cmd28.set_validation_proc { fog_validation_proc }
pejman_toolbars.add_item(cmd28)

#----------------------------------------------
cmd29 = UI::Command.new("Shadows") {
  Sketchup.active_model.shadow_info["DisplayShadows"] = !  Sketchup.active_model.shadow_info["DisplayShadows"] 
}
cmd29.small_icon = "pejmantoolbar/toggleshadows_sm.png"
cmd29.large_icon = "pejmantoolbar/toggleshadows_lg.png"
cmd29.tooltip = cmd29.status_bar_text = "Display Shadows"
def shadow_validation_proc
  if Sketchup.active_model.shadow_info["DisplayShadows"] == true
    return MF_CHECKED
  else
    return MF_UNCHECKED
  end
end  
cmd29.set_validation_proc { shadow_validation_proc }
pejman_toolbars.add_item(cmd29)

#----------------------------------------------
cmd30 = UI::Command.new("Display Shadow Settings") { Sketchup.send_action 10533 }
cmd30.large_icon = "pejmantoolbar/shadowsettings_LG.png"
cmd30.small_icon = "pejmantoolbar/shadowsettings_SM.png"
cmd30.tooltip = cmd30.status_bar_text = "Display Shadow Settings Dialog Box"
cmd30.menu_text = "ss"
# cmd30.set_validation_proc { tool_validation_proc("SketchTool") }
#gp_cd_standard_tb.add_item(cmd30)
pejman_toolbars.add_item(cmd30)

#----------------------------------------------
#----------------------------------------------

  # If we are not in pro, add a message to our tooltips to explain why the
  # buttons are grayed out.


#----------------------------------------------  # Toggle North Arrow command.
  # name = $sn_strings.GetString("Toggle North Arrow")
  north_arrow_command = UI::Command.new("Toggle North Arrow") {
    Sketchup.active_model.shadow_info['DisplayNorth'] =
        !Sketchup.active_model.shadow_info['DisplayNorth']
  }
  # cursor_path = Sketchup.find_support_file("northarrow.png", path)
  # small_cursor_path = Sketchup.find_support_file("northarrow_small.png", path)
  north_arrow_command.large_icon = "pejmantoolbar/northarrow.png"
  north_arrow_command.small_icon = "pejmantoolbar/northarrow_small.png"
  north_arrow_command.tooltip = "Toggle North Arrow"
  north_arrow_command.set_validation_proc {
    if Sketchup.active_model.shadow_info['DisplayNorth']
      MF_CHECKED
    else
      MF_ENABLED
    end
  }
  pejman_toolbars.add_item north_arrow_command


 #---------------------------------------------- # Create North Tool command.
  # name = $sn_strings.GetString("Set North Tool")
  north_tool_command = UI::Command.new("Set North Tool") {
    Sketchup.send_action('selectNorthTool:')
  }
  # cursor_path = Sketchup.find_support_file("northtool.png", path)
  # small_cursor_path = Sketchup.find_support_file("northtool_small.png", path)
  north_tool_command.large_icon = "pejmantoolbar/northtool.png"
  north_tool_command.small_icon = "pejmantoolbar/northtool_small.png"
  north_tool_command.tooltip = "Set North Tool"
  north_tool_command.set_validation_proc {
    if !Sketchup.is_pro?
      MF_GRAYED
    else
      MF_ENABLED
    end
  }
  pejman_toolbars.add_item north_tool_command


#----------------------------------------------  # Create North Tool command.
  # name = $sn_strings.GetString("Enter North Angle")
  # prompt345 = $sn_strings.GetString('North Angle (0-360)')
  north_text_command = UI::Command.new("Enter North Angle") {

    # Keep prompting the user until they cancel or enter a good value.
    done = false
    while done != true
      begin
        input = UI.inputbox [ "North Angle (0-360)" + ' '],
            [Sketchup.active_model.shadow_info['NorthAngle']], "Enter North Angle"
        if (input != false)
          angle = input[0].to_f % 360.0
          Sketchup.active_model.shadow_info['NorthAngle'] = angle
        end
        done = true
      rescue Exception => e
        puts "Solar North Extension Error: #{e.class}: #{e.message}"
        UI.messagebox($sn_strings.GetString(
            "Your input could not be understood. " +
            "Please enter a number between 0 and 360."))
      end
    end

  }
  # cursor_path = Sketchup.find_support_file("northtext.png", path)
  # small_cursor_path = Sketchup.find_support_file("northtext_small.png", path)
  north_text_command.large_icon = "pejmantoolbar/northtext.png"
  north_text_command.small_icon = "pejmantoolbar/northtext_small.png"
  north_text_command.tooltip = "Enter North Angle"
  north_text_command.set_validation_proc {
    if !Sketchup.is_pro?
      MF_GRAYED
    else
      MF_ENABLED
    end
  }
  pejman_toolbars.add_item north_text_command



end
